Description
If users are registered by an auth_sources

See Alternativecustom_authentication_ HowTo

the hook is not used.
:controller_account_success_authentication_after

source:trunk/app/controllers/account_controller.rb#L. 258

is it the expected behavior?

History

#1 - 2014-10-21 21:01 - Jean-Philippe Lang

- Status changed from New to Needs feedback

It should be called when a successfull password authentication occurs. Can you give more details about your problem or a patch that shows a
possible fix ?

#2 - 2014-10-23 06:20 - Sylvain V

| will double check the methods traversed by the onthe_fly creation process. But | think at register time, the path in the code doesn't use the hook. |
had to modify the account controller directly. I'm gonna isolate the behavior and post a use case and/or a patch.

| had modified the registration to setup new user in a Group / Role / Project at creation time.
#3 - 2014-10-28 11:50 - Sylvain V

- File redmine_register.png added

OK. I think | got the trick.

Here what I've done:

| added an custom AuthSource. See ticket description.

source at: source:branches/2.5-stable/

So the process:

1. /login app/controllers/account_controller.rb will call: def password_authentication

2. which call app/models/user.rb def self.try_to_login

which call app/models/auth_source.rb AuthSource.authenticate(login, password)
which call in loop AuthSources referenced in database with :onthefly_register => true
returning an attrs Hash, fetching some user info, email, firstName, lastName, if any

as those fields are required a register form will appear if something is missing
app/controllers/account_controller.rb def register

if the user enter valid information here, he will be registered

issuing a redirect_to my_account_path

©oNO oM

So app/controllers/account_controller.rb def successful_authentication is never called in this scheme. Nor
call_hook(:controller_account_success_authentication_after, {:user => user })
https://www.redmine.org/projects/redmine/wiki/Alternativecustom_authentication_HowTo
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/app/controllers/account_controller.rb#L258
https://www.redmine.org/projects/redmine/repository/svn/entry/branches/2.5-stable

As data fetched from my AuthSource is legacy data, | used this behavior above by forcing register to appear by setting a custom required boolean on
user. (Confirm)

#4 - 2014-10-28 19:10 - Jean-Philippe Lang

Thank you for this detailed explanation. I'd say it's the expected behaviour and I'm not in favor of changing this for compatibility reasons since existing
hooks may not expect an unsaved user. Maybe we can add a specific hook, can you tell what you need to do in your hook in this situation?

#5 - 2014-10-28 19:26 - Sylvain V
after submitting data, they are saved and authenticated...
so the hook's name let me think it will be called after authentication. | put my code directly in the controller inside register and it works as expected.

here: source:branches/2.5-stable/app/controllers/account_controller.rb#L.128

May be still the expected behavior...

What I'm doing at this stage, is to assign the newly AuthSource authenticated user to a project and group and role.
